# SeedPSD documentation

[Back to index](index.md)

## Known limitations

### IntegrityError raised when using parallel mode

When using parallel mode in loading large amount of files, IntegrityError may be raised. This transient phenomenon is known, but we can't pinpoint the exact cause of it.

Here at Resif we see those errors occuring while running 20 processes in parallel (5 workers with 4 cpu each). Lowering those processes to 16 permits to avoid those integrity errors.
So if you see integrity errors happening in the logs, please lower the number of workers working in parallel until no more of those errors appear.

Anyway, those integriy errors are handled by seedpsd. Files being processed while its happening are marked as unprocessed and the worker carry on with the next file. It is possible to re-process the "jumped" file

### miniSEED 3 not supported

SeedPSD is not currently designed to work with the [miniSEED 3 format](https://docs.fdsn.org/projects/miniseed3/en/latest/background.html).

### Software dependencies fixed to certain versions

SeedPSD was developed on a Linux system and tested only with Python 3.9.

Some software dependencies present bugs or incompatibilities:
- SQLAlchemy 2.x is mandatory for SeedPSD 
- ObsPy 1.4.1 is [incompatible with SQLAlchemy 2.x](https://github.com/obspy/obspy/blob/1.4.1/setup.py#L86), so it has been maintained in 1.4.0 (with an internal PPSD backport)
- Pendulum 3 [has a major bug](https://github.com/sdispater/pendulum/issues/797), so it has been maintained in version <3 (2.1.2 to date)

### PPSD as main calculation/plotting engine
Before going any further, please read the documentation pages about the [data feeding workflow](workflows.adoc) and the [PPSD parameters](ppsd-params.md).

#### Background

Since the initial specifications and the very first prototype of SeedPSD, the calculation and plotting engine has been the [PPSD class provided by ObsPy](https://docs.obspy.org/packages/autogen/obspy.signal.spectral_estimation.PPSD.html), and the working units have been :
- the daily Mseed file for data
- the channel for metadata.

In the context of Résif-DC, SeedPSD is integrated into data and metadata ingestion workflows via AMQP events. 
The processing of each event is totally independent of the others, and follows the order of arrival of AMQP messages on the associated queues.

#### Missing PSD calculations when the last window is too large

Due to the internal workings of the PPSD calculation algorithm and SeedPSD's design choices, it is possible that some parts 
of the PSDs may not be calculated. As shown in the diagram below, this usually occurs at the end of the day, when the last 
sliding window of the calculation exceeds the duration of the remaining data: in such a case, PPSD ignores the complete window.

Please note that the first window starts at the beginning of the stream and not at a fixed time, which makes it difficult to anticipate the appearance of the case.

![UML](modeling/missing-psd.png)

This behavior is currently known and has been scientifically validated, as it does not call into question the current use of SeedPSD at Résif-DC.

A possible workaround would be to retrieve the data (including the last minutes/seconds of the previous day)  from an FDSN webservice 
rather than directly from a Mseed file.  However, this approach calls into question a large part of SeedPSD's operation, 
since the unit of work is currently a daily Mseed file.  What's more, it's not impossible that the use of a continuous flow 
from a webservice would introduce other, even more problematic cases: double calculation of periods currently ignored, 
cascade shifting of calculation windows, etc.

#### Customization of plots
The plots are generated by Matplotlib, but their design is created by PPSD. SeedPSD therefore has very little control over their appearance and customization.

To implement more features, it will inevitably be necessary to heavily impact PPSD's source code and therefore integrate these changes into ObsPy.

#### Noise models
The noise models used on the plots are managed internally by PPSD and are not accessible to SeedPSD.

To implement more features, it will inevitably be necessary to heavily impact PPSD's source code and therefore integrate these changes into ObsPy.


### Database structure
Before going any further, please read the documentation page about the [database](database.md).

#### Background
Since the start of the project, SeedPSD has been designed with the unique objective of automating the generation of static 
images for PdFs and spectrograms using ObsPy's PPSD class. What's more, the initial specifications never envisaged the development 
of an interactive graphical interface to fully replace PQLX/SQLX.

The first prototype (developed by J. Touvier) used the [PPSD.save_npz()](https://docs.obspy.org/packages/autogen/obspy.signal.spectral_estimation.PPSD.save_npz.html) 
method to save calculation results as [NPZ files](https://numpy.org/doc/stable/reference/generated/numpy.lib.npyio.NpzFile.html#numpy.lib.npyio.NpzFile).

A database was soon required to manage the traceability of processed files, as well as metadata changes invalidating calculations. 
The database has also replaced NPZ files for storing calculation results. 

#### Implementation choices
As SeedPSD is based on PPSD, the values that need be stored in base (or NPZ) are only those that enable a PPSD object to be reconstructed:

from [PPSD.NPZ_STORE_KEYS_LIST_TYPES](https://docs.obspy.org/master/packages/autogen/obspy.signal.spectral_estimation.PPSD.NPZ_STORE_KEYS_LIST_TYPES.html#obspy.signal.spectral_estimation.PPSD.NPZ_STORE_KEYS_LIST_TYPES):
- ppsd._times_data (a list of start/end datetime of each segment)
- ppsd._times_gaps (a list of start/end datetime of each gap)
- ppsd._times_processed (a list of datetime processed)
- ppsd._binned_psds (a list of PSD values)

from [PPSD.NPZ_STORE_KEYS_SIMPLE_TYPES](https://docs.obspy.org/master/packages/autogen/obspy.signal.spectral_estimation.PPSD.NPZ_STORE_KEYS_SIMPLE_TYPES.html#obspy.signal.spectral_estimation.PPSD.NPZ_STORE_KEYS_SIMPLE_TYPES):
- ppsd.sampling_rate

Please note that the other parameters are either :
- stored in SeedPSD's source code ([PPSD.NPZ_STORE_KEYS_SIMPLE_TYPES](https://docs.obspy.org/master/packages/autogen/obspy.signal.spectral_estimation.PPSD.NPZ_STORE_KEYS_SIMPLE_TYPES.html#obspy.signal.spectral_estimation.PPSD.NPZ_STORE_KEYS_SIMPLE_TYPES). Read also the SeedPSD's documentation about [PPSD parameters](ppsd-params.md)).
- recalculated when each PPSD object is initialized ([PPSD.NPZ_STORE_KEYS_ARRAY_TYPES](https://docs.obspy.org/master/packages/autogen/obspy.signal.spectral_estimation.PPSD.NPZ_STORE_KEYS_ARRAY_TYPES.html#obspy.signal.spectral_estimation.PPSD.NPZ_STORE_KEYS_ARRAY_TYPES))
- unnecessary ([PPSD.NPZ_STORE_KEYS_VERSION_NUMBERS](https://docs.obspy.org/master/packages/autogen/obspy.signal.spectral_estimation.PPSD.NPZ_STORE_KEYS_VERSION_NUMBERS.html#obspy.signal.spectral_estimation.PPSD.NPZ_STORE_KEYS_VERSION_NUMBERS))

So, to have total control over PSDs, you need to use them via the PPSD object and not by querying the database directly and solely.

#### Potential improvements
It would be possible to change the database structure to store more information and enable direct queries without the need for a PPSD object.

The diagram below is only a proposal.
Please note that this new structure would make SeedPSD run more slowly and would inevitably increase the size of the database.

![PostgreSQL](modeling/database/db_model_for_GUI.png)

![UML](modeling/application/models-db_for_GUI.png)

### Metadata and instrument response required
SeedPSD is only intended to work with metadata in StationXML format. An instrumental response is mandatory and will be automatically retrieved by PPSD.

This causes numerous calls to the FDSN service. The extract of metadata kept in the database by SeedPSD is only used to detect a change in the metadata.

A possible improvement could therefore be to keep a larger metadata cache in the database and use it to directly feed PPSD without requiring a call to the FDSN webservice for each processing.

### AMQP forces the recalculation of files already processed
SeedPSD is intended not to process an already processed file unless its PSDs have been invalidated by a metadata change.

In the case of an AMQP message, processing of the Mseed file is forced regardless of its state. This ensures that a corrected file will be accepted even if the metadata does not change.

A possible improvement could be to store a hash of the file in the database: if the metadata does not change, an already known file could then be skipped if its hash has not changed.

### Unsupported server-side pooling

SQLAlchemy is NOT fully compatible with server-side connection pool, especially pgbouncer. 
This incompatibility is a known problem, but one for which SeedPSD has no fully functional solution.

We highly recommend:

- either avoiding the use of pgbouncer (at least for the SeedPSD database),
- or disabling the use of a connection pool in SeedPSD by configuring the appropriate variable.
